=== debian/changelog ===
upx-ucl (4.2.2-3) unstable; urgency=medium

  * Extract the list of architectures which binaries are supported by UPX to
    its own file, debian/supported-archs, and use it for tests run both by
    debian/rules and by autopkgtest. This fixes autopkgtest failure on s390x.
  * Drop, hopefully temporally, ppc64 and ppc64el from the list to fix FTBFS
    occurring on the former one in Debian, and on the latter one in Ubuntu.

 -- Robert Luberda <robert@debian.org>  Fri, 19 Jan 2024 00:32:09 +0100

upx-ucl (4.2.2-2) unstable; urgency=medium

  * debian/rules: Fix FTBFS on various architectures by ignoring test failures
    on architectures on which binary formats are not supported by UPX.
  * Fix a typo in a bug number in the preceding changelog entry.

 -- Robert Luberda <robert@debian.org>  Fri, 12 Jan 2024 21:36:31 +0100

upx-ucl (4.2.2-1) unstable; urgency=medium

  * New upstream version (closes: #1025053):
    - fixes heap-based buffer overflow issue CVE-2023-23456 (closes: #1033258);
    - fixes segmentation fault issue CVE-2023-23457 (closes: #1031874);
    - fixes execution of compressed MIPS binaries (closes: #1004137);
    - unfortunately both zlib and ucl libraries are now embedded into
      the upx-ucl binary - this should be fixed in the future somehow.
  * Remove no longer needed patches 02-arm64-crashes.patch and
    03-upstream-silence-compilation-warnings.patch.
  * Update debian/source/lintan-overrides in a try to disable its useless
    checks on debian/tests files (see: #1025452).
  * Update debian/rules for cmake that is now used by upstream.
  * Add new debian/test cases for the above CVE issues.
  * Update debian/copyright.
  * Update standards version to 4.6.2, no changes needed.

 -- Robert Luberda <robert@debian.org>  Thu, 11 Jan 2024 23:00:58 +0100
